/* RCS-based `Software Configuration Management' Header
 * $Id: rcs_scm.h,v 1.2 2002/03/25 13:59:18 gowen Exp $
 */

#define RCS_DATE_LEN   16
#define RCS_FN_LEN     64
#define SCM_FN_LEN     64
#define RCS_STATE_LEN  16
#define RCS_STR_LEN   128
#define RCS_VSN_LEN    16
#define SCM_VSN_LEN    16

#define TRUE       1
#define FALSE      0
#define NUL        '\0'

#include <string.h>

typedef enum
{
  AUTHOR_RCS,
  AUTHOR_SCM,
  DATE,
  FILE_RCS,
  FILE_SCM,
  ID,
  NAME,
  REVISION,
  STATE,
  VERSION,
  LAST_RCS,
  RCS_TYPES
} RCSnames;

RCSnames whichRCS;
static char *RCSlist[RCS_TYPES];

/* Copy these blocks into the (new) main.c file & uncomment them */
/* RCS info. blocks */
/*
 * static char RCSAuthor[]   = "$Author: gowen $";
 * static char SCMAuthor[]   = "$SCMauthor: Anon. $";
 * static char RCSDate[]     = "$Date: 2002/03/25 13:59:18 $";
 * static char RCSFile[]     = "$RCSfile: rcs_scm.h,v $";
 * static char SCMFile[]     = "$SCMfile: xace $";
 * static char RCSId[]       = "$Id: rcs_scm.h,v 1.2 2002/03/25 13:59:18 gowen Exp $";
 * static char RCSName[]     = "$Name:  $";
 * static char RCSRevision[] = "$Revision: 1.2 $";
 * static char RCSState[]    = "$State: Exp $";
 * static char SCMVersion[]  = "$SCMversion: 0.00 $";
 *
 * void setup_RCSlist(void)
 * {
 *   RCSlist[AUTHOR_RCS] = RCSAuthor;
 *   RCSlist[AUTHOR_SCM] = SCMAuthor;
 *   RCSlist[DATE]       = RCSDate;
 *   RCSlist[FILE_RCS]   = RCSFile;
 *   RCSlist[FILE_SCM]   = SCMFile;
 *   RCSlist[ID]         = RCSId;
 *   RCSlist[NAME]       = RCSName;
 *   RCSlist[REVISION]   = RCSRevision;
 *   RCSlist[STATE]      = RCSState;
 *   RCSlist[VERSION]    = SCMVersion;
 *   RCSlist[LAST_RCS]   = "$$";
 * }
 */

char *getRCSAuthor(void)
{
  static char author[RCS_STR_LEN];
  static char *p1,*p2;
  strcpy(author, "Anon.");
  p1 = RCSlist[AUTHOR_RCS];
  p2 = author;
  while((*p1!=' ') && (*p1!=NUL)) p1++;
  p1++;
  while((*p1!=' ') && (*p1!=NUL)) *p2++ = *p1++;
  *p2 = NUL;
  p1  = author;
  return(p1);
}

char *getSCMAuthor(void)
{
  static char author[RCS_STR_LEN];
  static char *p1,*p2;
  strcpy(author, "Anon.");
  p1 = RCSlist[AUTHOR_SCM];
  p2 = author;
  while((*p1!=' ') && (*p1!=NUL)) p1++;
  if (*p1 == NUL) return(p2);
  p1++;
  while((*p1!=' ') && (*p1!=NUL)) *p2++ = *p1++;
  *p2 = NUL;
  p1  = author;
  return(p1);
}

char *getRCSDate(void)
{
  static char date[RCS_DATE_LEN],temp[RCS_DATE_LEN];
  static char *p1,*p2;
  int i,j;
  strcpy(temp, "??/??/200?");
  p1 = RCSlist[DATE];
  p2 = temp;
  while((*p1!=' ') && (*p1!=NUL)) p1++;
  if (*p1 == NUL) return(p2);
  p1++;
  for (i=0; i<10; i++) *p2++ = *p1++;
  temp[10] = NUL;
  /* Convert to UK format */
  for (i=0; i<4; i++)
    {
      j = i + 6;
      date[j] = temp[i];
    }
  date[0]  = temp[8];
  date[1]  = temp[9];
  date[3]  = temp[5];
  date[4]  = temp[6];
  date[2]  = '/';
  date[5]  = '/';
  date[10] = NUL;
  p1       = date;
  return(p1);
}

char *getRCSFile(char flag)
{
  static char file[RCS_FN_LEN];
  static char *p1,*p2;
  strcpy(file, "Noname");
  p1 = RCSlist[FILE_RCS];
  p2 = file;
  while((*p1!=' ') && (*p1!=NUL)) p1++;
  if (*p1 == NUL) return(p2);
  p1++;
  while(*p1!=',') *p2++ = *p1++;
  *p2 = NUL;
  p1  = file;
  if (flag)
    {
      /* Remove trailing .ext if it exists */
      p2 = file;
      while (*p2 != NUL) p2++;
      while ((*p2!= '.') && (p2!=file)) p2--;
      if (p2 != file) *p2 = NUL;
    }
  return(p1);
}

char *getSCMFile(void)
{
  static char file[SCM_FN_LEN];
  static char *p1,*p2;
  strcpy(file, "Myprog");
  p1 = RCSlist[FILE_SCM];
  p2 = file;
  while((*p1!=' ') && (*p1!=NUL)) p1++;
  if (*p1 == NUL) return(p2);
  p1++;
  while(*p1!=' ') *p2++ = *p1++;
  *p2 = NUL;
  p1  = file;
  return(p1);
}

char *getRCSState(void)
{
  static char state[RCS_STATE_LEN];
  static char *p1,*p2;
  strcpy(state, "Unknown");
  p1 = RCSlist[STATE];
  p2 = state;
  while((*p1!=' ') && (*p1!=NUL)) p1++;
  if (*p1 == NUL) return(p2);
  p1++;
  while((*p1!=' ') && (*p1!=NUL)) *p2++ = *p1++;
  *p2 = NUL;
  p1  = state;
  return(p1);
}

char *getRCSVersion(void)
{
  static char version[RCS_VSN_LEN];
  static char *p1,*p2;
  strcpy(version, "1.0");
  p1 = RCSlist[REVISION];
  p2 = version;
  while((*p1!=' ') && (*p1!=NUL)) p1++;
  if (*p1 == NUL) return(p2);
  p1++;
  while((*p1!=' ') && (*p1!=NUL)) *p2++ = *p1++;
  *p2 = NUL;
  p1  = version;
  return(p1);
}

char *getSCMVersion(void)
{
  static char version[SCM_VSN_LEN];
  static char *p1,*p2;
  strcpy(version, "0.00");
  p1 = RCSlist[VERSION];
  p2 = version;
  while((*p1!=' ') && (*p1!=NUL)) p1++;
  if (*p1 == NUL) return(p2);
  p1++;
  while((*p1!=' ') && (*p1!=NUL)) *p2++ = *p1++;
  *p2 = NUL;
  p1  = version;
  return(p1);
}

void listRCSnames(void)
{
  for (whichRCS=AUTHOR_RCS; whichRCS<LAST_RCS; whichRCS++)
    printf("RCSlist[%2d] = %s\n", whichRCS, RCSlist[whichRCS]);
}

void print_scm(char * prog,
	       char * auth,
	       char * vsn,
	       char * state,
	       char * last)
{
/* Print program name, version, last modification date and author */
/* Call thus: print_scm(getSCMFile(),
 *                      getSCMAuthor(),
 *                      getSCMVersion(),
 *                      getRCSState(),
 *                      getRCSDate());
 *        or: print_scm(getRCSFile(FALSE),
 *                      getSCMAuthor(),
 *                      getSCMVersion(),
 *                      getRCSState(),
 *                      getRCSDate());
 *        or: print_scm(getRCSFile(FALSE),
 *                      getRCSAuthor(),
 *                      getRCSVersion(),
 *                      getRCSState(),
 *                      getRCSDate());
 *        or: print_scm(getRCSFile(FALSE),
 *                      getSCMAuthor(),
 *                      getRCSVersion(),
 *                      getRCSState(),
 *                      getRCSDate());
 *        or: print_scm(getRCSFile(FALSE),
 *                      getRCSAuthor(),
 *                      getSCMVersion(),
 *                      getRCSState(),
 *                      getRCSDate());
 * Note: Change FALSE to TRUE if you DON'T want the filename tag
 */
  printf(prog);
  printf(" Version ");
  printf(vsn);
  printf(" {");
  printf(state);
  printf("},");
  printf(" [");
  printf(last);
  printf("], (c) ");
  printf(auth);
  putchar('\n');
}

void print_us(char * prog,
	      char * usage)
{
/* Use it in this manner:
 * ...
 * if (argc < 2)
 *   {
 *     print_us(getRCSFile(TRUE), "[path/]filenam1[.tg1] ...");
 *     ...
 *     exit(1);
 *   }
 * ...
 */
  printf("Usage ");
  printf(prog);
  putchar(' ');
  puts(usage);
}

/* Change Log */
/*
 * $Log: rcs_scm.h,v $
 * Revision 1.2  2002/03/25 13:59:18  gowen
 * SCMFile support added.
 *
 * Revision 1.1  2002/03/25 13:24:30  gowen
 * Initial revision
 *
 *
 */

